local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.Spec = s.TalentMastery()
	x.Hasted = a.Hasted()
	x.Rage = s.Power("player", SPELL_POWER_RAGE )
	x.TimeToDie = s.TimeToDie("target") or 10
	x.InCombat = s.InCombat()
	x.Rage = s.Power("player", SPELL_POWER_RAGE )
	x.MaxRage = s.MaxPower("player", SPELL_POWER_RAGE)
	x.AoE = a.AoE()
	x.GCD = s.GlobalCooldown()
	
	a.Flash("Pummel", "Spell Reflection")
	a.Flash("Charge")
	a.FlashAll("Battle Shout", "Commanding Shout")
	if x.Spec == 1 then
		-- Arms
		x.DebuffColossusSmashRemains = s.MyDebuffDuration(86346--[[Colossus Smash]], "target")
		x.CooldownColossusSmashRemains = s.SpellCooldown(86346--[[Colossus Smash]])
		x.BuffRecklessnessRemains = s.BuffDuration(1719--[[Recklessness]], "player")
		x.CooldownRecklessnessRemains = s.SpellCooldown(1719--[[Recklessness]])
		x.TargetPCT = s.HealthPercent("target")
		a.Flash("Battle Stance")
		if x.AoE > 1 then
			a.Flash("Potion with Execute and Recklessness or Bloodlust or TTD <= 25",
					"Recklessness",
					"Bloodbath",
					"Avatar",
					"Skull Banner",
					"Berserker Rage",
					"Heroic Leap",
					"Sweeping Strikes",
					"Cleave",
					"Mortal Strike",
					"Dragon Roar w/ Bloodbath",
					"Thunder Clap",
					"Colossus Smash",
					"Whirlwind",
					"Shout for Rage")
		else
			a.Flash("Potion with Execute and Recklessness or Bloodlust or TTD <= 25",
					"Recklessness",
					"Bloodbath",
					"Avatar",
					"Skull Banner",
					"Berserker Rage",
					"Heroic Leap",
					"Heroic Strike",
					"Mortal Strike",
					"Dragon Roar w/ Bloodbath up and CS down",
					"Storm Bolt",
					"Colossus Smash",
					"Execute w/ CS or Recklessness or high Rage",
					"Dragon Roar w/ Bloodbath up or CS down during Execute",
					"Slam w/ CS running out or Recklessness",
					"Overpower",
					"Slam w/ low duration on CS",
					"Execute w/o Sudden Execute",
					"Overpower w/ Sudden Execute",
					"Slam w/ Rage >= 40",
					"Shout for Rage",
					"Heroic Throw")
		end
	elseif x.Spec == 2 then
		-- Fury
		x.DebuffColossusSmashRemains = s.MyDebuffDuration(86346--[[Colossus Smash]], "target")
		x.CooldownColossusSmashRemains = s.SpellCooldown(86346--[[Colossus Smash]])
		x.BuffRecklessnessRemains = s.BuffDuration(1719--[[Recklessness]], "player")
		x.CooldownRecklessnessRemains = s.SpellCooldown(1719--[[Recklessness]])
		x.TargetPCT = s.HealthPercent("target")
		x.EnrageRemains = s.BuffDuration(12880--[[Enrage]], "player")
		x.CooldownBloodthirstRemains = s.SpellCooldown(23881--[[Bloodthirst]])
		a.Flash("Battle Stance")
		a.Flash("auto_attack",
				"mogu_power_potion,if=(target.health.pct<20&buff.recklessness.up)|target.time_to_die<=25",
				"blood_fury,if=buff.bloodbath.up|(!talent.bloodbath.enabled&debuff.colossus_smash.up)",
				"recklessness,if=!talent.bloodbath.enabled&((cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5)&(target.time_to_die>(192*buff.cooldown_reduction.value)|target.health.pct<20))|buff.bloodbath.up&(target.time_to_die>(192*buff.cooldown_reduction.value)|target.health.pct<20)|target.time_to_die<=12",
				"avatar,if=enabled&(buff.recklessness.up|target.time_to_die<=25)",
				"skull_banner,if=buff.skull_banner.down&(((cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5)&target.time_to_die>192&buff.cooldown_reduction.up)|buff.recklessness.up)",
				"synapse_springs,if=!talent.bloodbath.enabled&debuff.colossus_smash.up|buff.bloodbath.up",
				"berserker_rage,if=buff.enrage.remains<1&cooldown.bloodthirst.remains>1",
				"bloodbath,if=enabled&(cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5|target.time_to_die<=20)",
				"heroic_strike,if=((debuff.colossus_smash.up&rage>=40)&target.health.pct>=20)|rage>=100&buff.enrage.up",
				"heroic_leap,if=debuff.colossus_smash.up",
				"storm_bolt,if=enabled&buff.cooldown_reduction.up&debuff.colossus_smash.up",
				"raging_blow,if=buff.raging_blow.stack=2&debuff.colossus_smash.up&target.health.pct>=20",
				"storm_bolt,if=enabled&buff.cooldown_reduction.down&debuff.colossus_smash.up",
				"bloodthirst,if=!(target.health.pct<20&debuff.colossus_smash.up&rage>=30&buff.enrage.up)",
				"wild_strike,if=buff.bloodsurge.react&target.health.pct>=20&cooldown.bloodthirst.remains<=1",
				"wait,sec=cooldown.bloodthirst.remains,if=!(target.health.pct<20&debuff.colossus_smash.up&rage>=30&buff.enrage.up)&cooldown.bloodthirst.remains<=1&cooldown.bloodthirst.remains",
				"dragon_roar,if=enabled&(!debuff.colossus_smash.up&(buff.bloodbath.up|!talent.bloodbath.enabled))",
				"colossus_smash",
				"storm_bolt,if=enabled&buff.cooldown_reduction.down",
				"execute,if=debuff.colossus_smash.up|rage>70|target.time_to_die<12",
				"raging_blow,if=target.health.pct<20|buff.raging_blow.stack=2|(debuff.colossus_smash.up|(cooldown.bloodthirst.remains>=1&buff.raging_blow.remains<=3))",
				"wild_strike,if=buff.bloodsurge.up",
				"bladestorm,if=enabled&cooldown.bloodthirst.remains>2",
				"raging_blow,if=cooldown.colossus_smash.remains>=3",
				"shockwave,if=enabled",
				"heroic_throw,if=debuff.colossus_smash.down&rage<60",
				"battle_shout,if=rage<70&!debuff.colossus_smash.up",
				"wild_strike,if=debuff.colossus_smash.up&target.health.pct>=20",
				"battle_shout,if=rage<70",
				"shattering_throw,if=cooldown.colossus_smash.remains>5",
				"wild_strike,if=cooldown.colossus_smash.remains>=2&rage>=70&target.health.pct>=20",
				"impending_victory,if=enabled&target.health.pct>=20&cooldown.colossus_smash.remains>=2")
	elseif x.Spec == 3 then
		-- Protection
		x.whb = a.wouldHaveBlocked()
		x.wha = a.wouldHaveAbsorbed()
		a.Flash("Defensive Stance")
		a.Flash("Berserker Rage (Protection)")
		if x.AoE == 1 then
			a.Flash("Demoralizing Shout", "Shield Block", "Shield Barrier", "Weakened Blows", "Victory Rush w/ low health",
					"Shield Slam",
			        "Revenge",
					"Shout for Rage",
					"Storm Bolt (prot)", "Bloodbath (prot)",
					"Execute (prot)",
					"Heroic Strike (prot)",
					"Shockwave", "Dragon Roar", "Whirlwind",
					"Devastate")
		elseif x.AoE == 2 then
			a.Flash("Demoralizing Shout", "Shield Block", "Shield Barrier", "Weakened Blows", "Victory Rush w/ low health",
					"Shield Slam",
			        "Revenge",
					"Shout for Rage",
					"Shockwave", "Dragon Roar", "Whirlwind",
					"Storm Bolt (prot)", "Bloodbath (prot)",
					"Execute (prot)",
					"Cleave (prot)",
					"Devastate")
		else
			a.Flash("Demoralizing Shout", "Shield Block", "Shield Barrier", "Weakened Blows", "Victory Rush w/ low health",
					"Shield Slam",
					"Bloodbath (prot)",
			        "Revenge",
					"Shockwave", "Dragon Roar", "Whirlwind",
					"Shout for Rage",
					"Heroic Leap (prot)",
					"Thunder Clap",
					"Cleave (prot)",
					"Devastate")
		end
	end
	
end)


